from django.utils.module_loading import autodiscover_modules

from .utils import extract_uid


class RecipientRegister(object):
    """ """
    _registry = {}

    def add(self, recipient):
        self._registry[recipient.__name__] = recipient

    def all(self):
        return self._registry.values()

    def get(self, recipient_uid):
        (class_name, pk) = extract_uid(recipient_uid)
        return self._registry[class_name], pk


recipient_register = RecipientRegister()


def autodiscover():
    """autodiscover and import conditions.py files to feed register
    """
    autodiscover_modules('recipients')
