from datetime import timedelta
from eVotUM.Cripto.shamirsecret import generateSecretTime

from django.utils import timezone
from django.conf import settings

from evotevotings.services.routers import ASrouter


def get_references(election_id=None, page=1, search=None):
    """ Method to search vote references through
    the Anonymizer Service """
    # List to hold the returned references
    references = []
    more = False
    # Sanity check
    if election_id is None:
        return (references, more)
    # Connect to the Anonymizer Service
    try:
        as_router = ASrouter()
        (references, more) = as_router.list_references(
            election_id, page, search)
    except Exception as e:
        # TODO: Log
        print e

    return (references, more)


def pin_expiration_date():
    return timezone.now() + timedelta(seconds=settings.PIN_TIMETOLIVE)


def generate_pin():
    (secret, _) = generateSecretTime(settings.PIN_SIZE,
                                     settings.PIN_TIMETOLIVE)
    return secret
